
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Media_assetsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.create(
            {
                id: data.id || undefined,
        
        media_type: data.media_type
        ||
        null
            ,
            
        caption: data.caption
        ||
        null
            ,
            
        tags: data.tags
        ||
        null
            ,
            
        captured_at: data.captured_at
        ||
        null
            ,
            
        source: data.source
        ||
        null
            ,
            
        is_private: data.is_private
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await media_assets.setTenant( data.tenant || null, {
            transaction,
        });
        
        await media_assets.setUploaded_by( data.uploaded_by || null, {
            transaction,
        });
        
        await media_assets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'images',
                belongsToId: media_assets.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: media_assets.id,
            },
            data.attachments,
            options,
        );
        

        return media_assets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const media_assetsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                media_type: item.media_type
            ||
            null
            ,
            
                caption: item.caption
            ||
            null
            ,
            
                tags: item.tags
            ||
            null
            ,
            
                captured_at: item.captured_at
            ||
            null
            ,
            
                source: item.source
            ||
            null
            ,
            
                is_private: item.is_private
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const media_assets = await db.media_assets.bulkCreate(media_assetsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < media_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.media_assets.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: media_assets[i].id,
                },
                data[i].images,
                options,
            );
        }
        
        for (let i = 0; i < media_assets.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.media_assets.getTableName(),
                    belongsToColumn: 'attachments',
                    belongsToId: media_assets[i].id,
                },
                data[i].attachments,
                options,
            );
        }
        

        return media_assets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const media_assets = await db.media_assets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.media_type !== undefined) updatePayload.media_type = data.media_type;
        
        
        if (data.caption !== undefined) updatePayload.caption = data.caption;
        
        
        if (data.tags !== undefined) updatePayload.tags = data.tags;
        
        
        if (data.captured_at !== undefined) updatePayload.captured_at = data.captured_at;
        
        
        if (data.source !== undefined) updatePayload.source = data.source;
        
        
        if (data.is_private !== undefined) updatePayload.is_private = data.is_private;
        
        
        updatePayload.updatedById = currentUser.id;

        await media_assets.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await media_assets.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.uploaded_by !== undefined) {
            await media_assets.setUploaded_by(
              
              data.uploaded_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await media_assets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'images',
                belongsToId: media_assets.id,
            },
            data.images,
            options,
        );
        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.media_assets.getTableName(),
                belongsToColumn: 'attachments',
                belongsToId: media_assets.id,
            },
            data.attachments,
            options,
        );
        

        return media_assets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of media_assets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of media_assets) {
                await record.destroy({transaction});
            }
        });


        return media_assets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findByPk(id, options);

        await media_assets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await media_assets.destroy({
            transaction
        });

        return media_assets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const media_assets = await db.media_assets.findOne(
            { where },
            { transaction },
        );

        if (!media_assets) {
            return media_assets;
        }

        const output = media_assets.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await media_assets.getTenant({
            transaction
        });
        
        
        output.uploaded_by = await media_assets.getUploaded_by({
            transaction
        });
        
        
        output.images = await media_assets.getImages({
            transaction
        });
        
        
        output.attachments = await media_assets.getAttachments({
            transaction
        });
        
        
        output.organizations = await media_assets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'uploaded_by',
        
        where: filter.uploaded_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.uploaded_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.uploaded_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'images',
      },

      {
        model: db.file,
        as: 'attachments',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.caption) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'media_assets',
                        'caption',
                        filter.caption,
                    ),
                };
            }
            
            if (filter.tags) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'media_assets',
                        'tags',
                        filter.tags,
                    ),
                };
            }
            
            if (filter.source) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'media_assets',
                        'source',
                        filter.source,
                    ),
                };
            }
            

            
            

            
            if (filter.captured_atRange) {
                const [start, end] = filter.captured_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    captured_at: {
                    ...where.captured_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    captured_at: {
                    ...where.captured_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.media_type) {
                where = {
                    ...where,
                media_type: filter.media_type,
            };
            }
            
            if (filter.is_private) {
                where = {
                    ...where,
                is_private: filter.is_private,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.media_assets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'media_assets',
                        'caption',
                        query,
                    ),
                ],
            };
        }

        const records = await db.media_assets.findAll({
            attributes: [ 'id', 'caption' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['caption', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.caption,
        }));
    }

    
};

